# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
class VGastoAgente < ActiveRecord::Base
  #untranslate_all
  belongs_to :partida
  belongs_to :subpartida

  # valores[0] = agente_id, valores[1] = etapa_id, valores[2] = moneda_id, valores[3] = tasa_cambio, valores[4] = partida_id
  # scope :subpartidas_partida, lambda { |*valores| {
  #                               :select => "subpartida_id as fila_id, implementador_id as columna_id, #{importe valores[2], valores[3]} as importe, proyecto_id as proyecto_id", 
  #                               :group => "etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id, proyecto_id, subpartida_id",
  #                               :conditions => condiciones(valores[0], valores[1], valores[2], valores[4])  } }



  # valores[0] = agente_id, valores[1] = fecha_inicio, valores[2] = fecha_fin,  valores[3] = moneda_id, valores[4] = tasa_cambio, valores[5] = partida_id, valores[6] = proyecto_nil
  scope :partida, lambda { |*valores| {
                                 :select => "partida_id, implementador_id, #{importe valores[3], valores[4]} as importe #{valores[6] ? ', proyecto_id ' : ''}", 
                                 :group => "#{valores[3] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id #{valores[6] ? ', proyecto_id ' : ''}",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[5], :proyecto_nil => valores[6])  } }

  # valores[0] = agente_id, valores[1] = fecha_inicio, valores[2] = fecha_fin,  valores[3] = moneda_id, valores[4] = tasa_cambio, valores[5] = partida_id, valores[6] = subpartida_id, valores[7] = subpartida_nil, valores[8] = proyecto_nil
  scope :subpartida, lambda { |*valores| {
                                 :select => "subpartida_id, subpartida_nombre, partida_id, partida_nombre, implementador_id, #{importe valores[3], valores[4]} as importe #{valores[8] ? ', proyecto_id ' : ''}", 
                                 :group => "#{valores[3] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id, subpartida_id #{valores[8] ? ', proyecto_id ' : ''}",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[5], :subpartida =>  valores[6], :subpartida_nil => valores[7], :proyecto_nil => valores[8]  )  } }

  # valores[0] = agente_id, valores[1] = fecha_inicio, valores[2] = fecha_fin,  valores[3] = moneda_id, valores[4] = tasa_cambio, valores[5] = partida_id
  scope :partida_asignado_proyecto, lambda { |*valores| {
                                 :select => "partida_id, implementador_id, #{importe valores[3], valores[4]} as importe ", 
                                 :group => "#{valores[3] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id, proyecto_id",
                                 :conditions => condiciones_partida_asignado_proyecto(valores[0], valores[1], valores[2], valores[3], valores[5]) } }

  def self.condiciones_partida_asignado_proyecto agente_id, fecha_inicio, fecha_fin, moneda_id, partida_id
    cadena = "`v_gasto_agente`.`implementador_id` = ?  AND `v_gasto_agente`.`fecha` BETWEEN ? AND ?  AND `v_gasto_agente`.`partida_id` = ? AND `v_gasto_agente`.`proyecto_id` IS NOT NULL"
    if moneda_id == "todas"
      condiciones = [cadena, agente_id, fecha_inicio, fecha_fin, partida_id ]
    else
      cadena << " AND `v_gasto_agente`.`moneda_id` = ? " 
      condiciones = [cadena, agente_id, fecha_inicio, fecha_fin, partida_id, moneda_id ]
    end
  end

  # valores[0] = agente_id, valores[1] = fecha_inicio, valores[2] = fecha_fin,  valores[3] = moneda_id, valores[4] = tasa_cambio, valores[5] = partida_id, valores[6] = subpartida_id, valores[7] = subpartida_nil
  scope :subpartida_asignado_proyecto, lambda { |*valores| {
                                 :select => "subpartida_id, subpartida_nombre, partida_id, partida_nombre, implementador_id, #{importe valores[3], valores[4]} as importe ", 
                                 :group => "#{valores[3] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id, subpartida_id, proyecto_id",
                                 :conditions => condiciones_subpartida_asignado_proyecto( valores[0], valores[1], valores[2], valores[3], valores[5], valores[6], valores[7] )  } }


  def self.condiciones_subpartida_asignado_proyecto agente_id, fecha_inicio, fecha_fin, moneda_id, partida_id, subpartida_id, subpartida_nil
    unless subpartida_nil
      cadena =  "`v_gasto_agente`.`implementador_id` = ?  AND `v_gasto_agente`.`fecha` BETWEEN ? AND ? AND `v_gasto_agente`.`partida_id` = ? AND `v_gasto_agente`.`subpartida_id` = ? AND `v_gasto_agente`.`proyecto_id` IS NOT NULL"
      return condiciones = [cadena, agente_id, fecha_inicio, fecha_fin, partida_id, subpartida_id  ] if moneda_id == "todas"
      cadena << " AND `v_gasto_agente`.`moneda_id` = ? " unless moneda_id == "todas"
      return condiciones = [cadena, agente_id, fecha_inicio, fecha_fin, partida_id, subpartida_id, moneda_id ] unless moneda_id == "todas"
    else
      cadena = "`v_gasto_agente`.`implementador_id` = ?  AND `v_gasto_agente`.`fecha` BETWEEN ? AND ? AND `v_gasto_agente`.`partida_id` = ? AND `v_gasto_agente`.`subpartida_id` IS NULL AND `v_gasto_agente`.`proyecto_id` IS NOT NULL"
      return condiciones = [cadena, agente_id, fecha_inicio, fecha_fin, partida_id  ] if moneda_id == "todas"
      cadena << " AND `v_gasto_agente`.`moneda_id` = ? " unless moneda_id == "todas"
      return condiciones = [cadena, agente_id, fecha_inicio, fecha_fin, partida_id, moneda_id  ] unless moneda_id == "todas"
    end
  end


  # valores[0] = agente_id, valores[1] = fecha_inicio, valores[2] = fecha_fin,  valores[3] = moneda_id, valores[4] = tasa_cambio, valores[5] = partida_id, valores[6] = subpartida_id, valores[7] = subpartida_nil
  scope :subpartida_por_proyecto, lambda { |*valores| {
                                 :select => "subpartida_id, subpartida_nombre, partida_id, partida_nombre, implementador_id, #{importe valores[3], valores[4]} as importe, proyecto_nombre", 
                                 :group => "#{valores[3] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id, subpartida_id #{valores[8] ? ', proyecto_id ' : ''}",
                                 :conditions => condiciones_subpartida_asignado_proyecto( valores[0], valores[1], valores[2], valores[3], valores[5], valores[6], valores[7] )}}

  def self.importe moneda_id, tasa_cambio
    importe = if  moneda_id == "todas";  "sum(importe_moneda_base)"
               elsif tasa_cambio == "0"; "sum(importe)"
               elsif tasa_cambio == "1"; "sum(importe_moneda_base)"; end
    return importe
  end  

  def self.condiciones agente_id, fecha_inicio, fecha_fin, moneda_id, partida_id, otros={}
     condiciones = {"implementador_id" => agente_id, "fecha" => fecha_inicio..fecha_fin }
     condiciones["moneda_id"] = moneda_id unless moneda_id == "todas"
     condiciones["partida_id"] = partida_id if partida_id
     condiciones["subpartida_id"] = otros[:subpartida] if otros[:subpartida]
     condiciones["subpartida_id"] = nil if otros[:subpartida_nil]
     condiciones["proyecto_id"] = nil if otros[:proyecto_nil]
     return condiciones
  end


end
