class ProcedureXmlGastosDeUnProyecto < ActiveRecord::Migration
  def self.up
    execute <<-__EOI
CREATE DEFINER=CURRENT_USER FUNCTION `xml_gastos_de_un_proyecto`(proyecto_id INTEGER) RETURNS longtext CHARSET utf8
BEGIN

  DECLARE tmp longtext;

  set tmp=(SELECT  
    group_concat(
    '<gasto ',
      'id="',g.id,'" ',
      'fecha="',ifnull(g.fecha,''),'" '
      'concepto="',ifnull(g.concepto,''),'" ',
      'libro_nombre="',ifnull(l.nombre,''),'" ',
      'moneda_abreviatura="',ifnull(m.abreviatura,''),'" ',
      'numero_factura="',ifnull(g.numero_factura,''),'" ',
      'emisor_factura="',ifnull(g.emisor_factura,''),'" ',
      'observaciones="',ifnull(g.observaciones,''),'" ',
      'importe="',ifnull(g.importe,''),'" ',
      'impuestos="',ifnull(g.impuestos,''),'" ',
      'partida_codigo="',ifnull(par.codigo,''),'">',
      IFNULL(xml_actividad_de_un_gasto(g.id),''),
      IFNULL(xml_financiador_de_un_gasto(g.id),''), 
    '</gasto>'
    SEPARATOR '') 
FROM 
  gasto g,
  proyecto p, 
  gasto_x_proyecto gxp,
  libro l,
  partida par,
  moneda m 
WHERE 
  p.id=proyecto_id and 
  p.id=gxp.proyecto_id and 
  g.id=gxp.gasto_id and
  g.libro_id=l.id and
  g.partida_id=par.id and
  g.moneda_id=m.id
  )
;
  SET tmp= concat(
    '<?xml version="1.0" encoding="UTF-8"?><gastos proyecto_id="',
    proyecto_id,
    '">',
    IFNULL(tmp,''),
    '</gastos>'
    );

  RETURN tmp;
END;
__EOI

  end

  def self.down
    execute "DROP FUNCTION IF EXISTS xml_gastos_de_un_proyecto"
  end
end
