class ProcedureXmlPptoDeUnProyecto < ActiveRecord::Migration
  def self.up
    execute <<-__EOI
CREATE DEFINER=CURRENT_USER FUNCTION `xml_ppto_de_un_proyecto`(proyecto_id INTEGER) RETURNS longtext CHARSET utf8
BEGIN

  DECLARE tmp longtext;

  set tmp=(SELECT  
    group_concat(
    '<linea_ppto ',
      'id="',p.id,'" ',
      'fecha_inicio="',ifnull(p.fecha_inicio,''),'" '
      'fecha_fin="',ifnull(p.fecha_fin,''),'" '
      'importe="',ifnull(p.importe,''),'" ',
      'coste_unitario="',ifnull(p.coste_unitario,''),'" ',
      'numero_unidades="',ifnull(p.numero_unidades,''),'" ',
      'agente_nombre="',ifnull(a.nombre,''),'" ',
      'moneda_abreviatura="',ifnull(m.abreviatura,''),'" ',
      'partida_codigo="',ifnull(par.codigo,''),'" ',      
      'observaciones="',ifnull(p.observaciones,''),'" ',      
      'subpartida="',ifnull(sub.nombre,''),'" ',      
      'concepto="',ifnull(p.concepto,''),'">',
      IFNULL(xml_actividad_de_un_ppto(p.id),''),
      IFNULL(xml_financiador_de_un_ppto(p.id),''), 
    '</linea_ppto>'
    SEPARATOR '') 
FROM 
  presupuesto p,
  agente a, 
  presupuesto_x_proyecto pxp, 
  moneda m,
  partida par,
  subpartida sub
WHERE 
  p.id=pxp.presupuesto_id
  and p.agente_id = a.id
  and p.moneda_id=m.id
  and p.partida_id=par.id
  and pxp.proyecto_id=proyecto_id
  and p.subpartida_id=sub.id
  )
;
  SET tmp= concat(
    '<?xml version="1.0" encoding="UTF-8"?><ppto proyecto_id="',
    proyecto_id,
    '">',
    IFNULL(tmp,''),
    '</ppto>'
    );

  RETURN tmp;
END;
__EOI

  end

  def self.down
    execute "DROP FUNCTION IF EXISTS xml_ppto_de_un_proyecto"
  end
end
