class ProcedureXmlFinanciadorDeUnPpto2 < ActiveRecord::Migration
  def self.up
    execute "DROP FUNCTION IF EXISTS xml_financiador_de_un_ppto"
    execute <<-__EOI
CREATE DEFINER=CURRENT_USER FUNCTION `xml_financiador_de_un_ppto`(ppto_id INT) RETURNS longtext CHARSET utf8
BEGIN

  DECLARE tmp longtext;
  set tmp=
    (SELECT  
      group_concat(
        '<financiador ',
        'nombre="',ifnull(a.nombre,''),'" ',  
        'importe="',ifnull(pxa.importe,''),'" ',
        '/>'
      SEPARATOR '') as tmp

    FROM
      agente a,
      presupuesto_x_agente pxa
    WHERE
      a.id=pxa.agente_id
      and pxa.presupuesto_id = ppto_id); 

return tmp;
END;
__EOI

  end

  def self.down
    execute "DROP FUNCTION IF EXISTS xml_financiador_de_un_ppto"
  end
end
