class ActualizarVistasTablon < ActiveRecord::Migration
  def self.up
    self.down
   
    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_gasto` AS 



select 
A.id as financiador_id,A.nombre as financiador_nombre,
AI.id as implementador_id,AI.nombre as implementador_nombre,
AC.id as actividad_id,AC.codigo as actividad_codigo,AC.descripcion as actividad_nombre,
PY.id as proyecto_id, PY.nombre as proyecto_nombre,
PT.id as partida_id,PT.nombre as partida_nombre,
SPT.id as subpartida_id,SPT.nombre as subpartida_nombre,
PTF.id as partida_proyecto_id,PTF.nombre as partida_proyecto_nombre,
G.id as gasto_id,
G.moneda_id as moneda_id,
M.abreviatura as moneda_nombre,
PY.moneda_id as moneda_base_id,
MAUX.nombre as moneda_base_nombre,
IFNULL(TCG.tasa_cambio,0) as tasa_cambio,
G.fecha,
((GXA.importe * GXAC.importe)/G.importe) * GXP.porcentaje as importe,
case when G.moneda_id = PY.moneda_id then
((GXA.importe * GXAC.importe)/G.importe) * GXP.porcentaje
else
((GXA.importe * GXAC.importe)/G.importe) * IFNULL(TCG.tasa_cambio,0) * GXP.porcentaje
end as importe_moneda_base


from gasto G
inner join gasto_x_proyecto GXP on G.id = GXP.gasto_id
inner join proyecto PY on GXP.proyecto_id = PY.id
inner join proyecto_x_financiador PXF on PY.id = PXF.proyecto_id 
inner join gasto_x_agente GXA on G.id = GXA.gasto_id and GXA.agente_id = PXF.agente_id
inner join gasto_x_actividad GXAC on GXA.gasto_id = GXAC.gasto_id and GXA.proyecto_id = GXAC.proyecto_id
inner join agente A on GXA.agente_id = A.id
inner join actividad AC on GXAC.actividad_id = AC.id
inner join libro L on G.libro_id = L.id
inner join agente AI on AI.id = L.agente_id
inner join moneda M on G.moneda_id = M.id
left join moneda MAUX on MAUX.id = PY.moneda_id
left join tasa_cambio_gasto TCG on TCG.gasto_id = G.id and TCG.proyecto_id = PY.id
inner join partida PT on G.partida_id = PT.id
left join subpartida SPT on GXP.subpartida_id = SPT.id
left join partida_x_partida_financiacion PXPA on PT.id = PXPA.partida_id
left join partida_financiacion PTF on PTF.id = PXPA.partida_financiacion_id
;
__EOI

    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_presupuesto` AS 


select 
A.id as financiador_id,A.nombre as financiador_nombre,
AC.id as actividad_id,AC.codigo as actividad_codigo,AC.descripcion as actividad_nombre,
P.agente_id as implementador_id, AIMP.nombre as implementador_nombre,
PY.id as proyecto_id, PY.nombre as proyecto_nombre,
E.id as etapa_id,E.nombre as etapa_nombre,
PT.id as partida_id,PT.nombre as partida_nombre,
PTF.id as partida_proyecto_id,PTF.nombre as partida_proyecto_nombre,
P.id as presupuesto_id,
P.moneda_id as moneda_id,
M.abreviatura as moneda_nombre,
PY.moneda_id as moneda_base_id,
MAUX.nombre as moneda_base_nombre,
IFNULL(P.tasa_cambio,0) as tasa_cambio,
((PXA.importe * PXAC.importe)/P.importe) as importe,
((PXA.importe * PXAC.importe)/P.importe) * P.tasa_cambio as importe_moneda_base

from 
presupuesto_x_agente PXA
inner join presupuesto_x_actividad PXAC on PXA.presupuesto_id = PXAC.presupuesto_id
inner join agente A on PXA.agente_id = A.id
inner join actividad AC on PXAC.actividad_id = AC.id
inner join presupuesto P on PXA.presupuesto_id = P.id
inner join moneda M on P.moneda_id = M.id
inner join agente AIMP on P.agente_id = AIMP.id
inner join proyecto PY on P.proyecto_id = PY.id
left join moneda MAUX on MAUX.id = PY.moneda_id
inner join etapa E on E.proyecto_id = PY.id and P.etapa_id = E.id
inner join partida PT on P.partida_id = PT.id
left join partida_x_partida_financiacion PXPA on PT.id = PXPA.partida_id
left join partida_financiacion PTF on PTF.id = PXPA.partida_financiacion_id
;
__EOI

    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_presupuesto_detallado` AS 


select 
A.id as financiador_id,A.nombre as financiador_nombre,
AC.id as actividad_id,AC.codigo as actividad_codigo,AC.descripcion as actividad_nombre,
P.agente_id as implementador_id, AIMP.nombre as implementador_nombre,
PY.id as proyecto_id, PY.nombre as proyecto_nombre,
PT.id as partida_id,PT.nombre as partida_nombre,
PTF.id as partida_proyecto_id,PTF.nombre as partida_proyecto_nombre,
P.id as presupuesto_id,
P.moneda_id as moneda_id,
M.abreviatura as moneda_nombre,
PY.moneda_id as moneda_base_id,
MAUX.nombre as moneda_base_nombre,
IFNULL(P.tasa_cambio,0) as tasa_cambio,
PD.fecha_inicio,
PD.fecha_fin,
PD.mes,
(PD.importe * ((PXA.importe * PXAC.importe)/P.importe))/P.importe as importe,
((PD.importe * ((PXA.importe * PXAC.importe)/P.importe))/P.importe) * P.tasa_cambio as importe_moneda_base

from 
presupuesto_x_agente PXA
inner join presupuesto_x_actividad PXAC on PXA.presupuesto_id = PXAC.presupuesto_id
inner join agente A on PXA.agente_id = A.id
inner join actividad AC on PXAC.actividad_id = AC.id
inner join presupuesto P on PXA.presupuesto_id = P.id
inner join presupuesto_detallado PD on P.id = PD.presupuesto_id
inner join moneda M on P.moneda_id = M.id
inner join agente AIMP on P.agente_id = AIMP.id
inner join proyecto PY on P.proyecto_id = PY.id
left join moneda MAUX on MAUX.id = PY.moneda_id
inner join partida PT on P.partida_id = PT.id
left join partida_x_partida_financiacion PXPA on PT.id = PXPA.partida_id
left join partida_financiacion PTF on PTF.id = PXPA.partida_financiacion_id
__EOI
  end

  def self.down
    execute "DROP VIEW IF EXISTS `v_gasto`"
    execute "DROP VIEW IF EXISTS `v_presupuesto`"
    execute "DROP VIEW IF EXISTS `v_presupuesto_detallado`"

    
  end	
end
