class VPresupuestoAgenteDetallado < ActiveRecord::Migration
  def self.up

    execute "DROP VIEW IF EXISTS `v_presupuesto_agente_detallado`"

    execute <<-__EOI
CREATE ALGORITHM=UNDEFINED DEFINER=CURRENT_USER SQL SECURITY DEFINER VIEW `v_presupuesto_agente_detallado` AS 


select 
P.agente_id as implementador_id, AIMP.nombre as implementador_nombre,
PT.id as partida_id,PT.nombre as partida_nombre, PT.codigo as partida_codigo,
P.id as presupuesto_id,
P.moneda_id as moneda_id,
P.concepto as presupuesto_concepto,
P.proyecto_id as proyecto_id,
M.abreviatura as moneda_nombre,
SP.nombre as subpartida_nombre,
P.subpartida_id as subpartida_id,
IFNULL(P.tasa_cambio,0) as tasa_cambio,
PD.fecha_inicio,
PD.fecha_fin,
PD.mes,
PD.importe as importe,
PD.importe * P.tasa_cambio as importe_moneda_base

from 
presupuesto P
inner join presupuesto_detallado PD on P.id = PD.presupuesto_id
inner join moneda M on P.moneda_id = M.id
inner join agente AIMP on P.agente_id = AIMP.id
inner join partida PT on P.partida_id = PT.id
left join subpartida SP on SP.id = P.subpartida_id
__EOI

  end

  def self.down
    execute "DROP VIEW IF EXISTS `v_presupuesto_agente_detallado`"
  end
end
