class TransferenciaXFinanciador < ActiveRecord::Migration
  def self.up
    # Crea la nueva tabla de relaciones
    create_table :transferencia_x_agente do |t|
      t.integer :transferencia_id
      t.integer :agente_id
      t.decimal :importe, :precision => 24, :scale => 2, :default => 0.0
      t.timestamps
    end
    # Carga datos en la nueva tabla de relaciones
    errores = false
    Transferencia.all.each do |transf|
      agt = Agente.find_by_id(transf.agente_id)
      if agt && agt.financiador 
        txa = TransferenciaXAgente.new(:agente_id => agt.id, :transferencia_id => transf.id, :importe => transf.importe)
        txa.save
        unless txa.errors.empty?
          errores = true
          puts "Error al cambiar la relacion de TransferenciaXAgente para la transferencia con id: " + transf.id.to_s
        end
      else
        puts "La transferencia con id " + transf.id.to_s + " no tiene agente financiador"
      end
    end 
    # Elimina la columna vieja de relacion
    remove_column( :transferencia, :agente_id) unless errores
  end

  def self.down
    # Restituye la columna de relacion con agente
    add_column :transferencia, :agente_id, :integer
    # Devuelve los datos de agentes a la transferencia
    errores = false
    Transferencia.all.each do |transf|
      txf = TransferenciaXAgente.find_by_transferencia_id(transf.id)
      if txf
        transf.agente_id = txf.agente_id
        transf.save
        unless transf.errors.empty?
          errores = true
          puts "Error al asignar el financiador con id " + txf.agente_id.to_s + " a la transferencia con id " + transf.id.to_s
        end
      end
    end
    # Elimina la tabla de relaciones
    drop_table :transferencia_x_agente unless errores
  end
end
