class AddFormaPagoToPagoSocio < ActiveRecord::Migration
  def self.up
    add_column :pago_socio, :forma_pago_socio_id, :integer
    # Si no existe, crea la forma de pago "Especie"
    especie = FormaPagoSocio.find_or_create_by_forma_pago _('Especie')
    # Convierte los pagos en especie en forma de pago
    PagoSocio.all(:conditions => {:especie => true}).each do |ps|
      ps.forma_pago_socio_id = especie
      ps.save
    end
    remove_column :pago_socio, :especie
  end

  def self.down
    add_column :pago_socio, :especie, :boolean
    # Devuelve a especie las formas de pago de especie
    especie = FormaPagoSocio.find_by_forma_pago _('Especie')
    PagoSocio.all(:conditions => {:forma_pago_socio_id => especie.id}).each do |ps|
      ps.especie = true
      ps.save 
    end if especie
    remove_column :pago_socio, :forma_pago_socio_id
  end
end
