class CreateValoresIntermediosIndicador < ActiveRecord::Migration
  def self.up
    create_table :valor_intermedio_x_indicador do |t|
      t.integer :indicador_id
      t.date :fecha
      t.decimal :porcentaje, :precision => 5, :scale => 4
      t.string :comentario
      t.integer :usuario_id

      t.timestamps
    end

    # Recorremos todos los indicadores
    Indicador.all.each do |ind|
      obj = ind.objetivo_especifico || ind.resultado
      # Si estan vinculados a un objeto y tienen un porcentaje, lo creamos
      if ind.porcentaje && obj
        uxp = obj.proyecto.usuario_x_proyecto.first(:conditions => {:rol => "coordinador"})
        ValorIntermedioXIndicador.create(:indicador_id => ind.id, :porcentaje => ind.porcentaje, :fecha => ind.updated_at.to_date, :usuario_id => uxp ? uxp.usuario_id : nil)
      end
    end

    remove_column :indicador, :porcentaje
  end

  def self.down
    add_column :indicador, :porcentaje, :decimal, :precision => 5, :scale => 4 

    # Metemos el ultimo valor intermedio en el porcentaje del indicador
    Indicador.all.each do |ind|
      vixi = ValorIntermedioXIndicador.last(:order => "fecha", :conditions => {:indicador_id => ind.id})
      if vixi
        ind.porcentaje = vixi.porcentaje
        ind.save
      end
    end

    drop_table :valor_intermedio_x_indicador
  end
end
