class CreateValoresIntermediosSubactividad < ActiveRecord::Migration
  def self.up
    create_table :valor_intermedio_x_subactividad do |t|
      t.integer :subactividad_id
      t.date :fecha
      t.decimal :porcentaje, :precision => 5, :scale => 4
      t.text :estado
      t.string :comentario
      t.integer :usuario_id

      t.timestamps
    end

    # Recorremos todas las subactividades
    Subactividad.all.each do |sub|
      # Y si estan realizadas, generamos el cumplimiento al 100%
      uxp = sub.actividad.proyecto.usuario_x_proyecto.first(:conditions => {:rol => "coordinador"})
      ValorIntermedioXSubactividad.create(:subactividad_id => sub.id, :porcentaje => sub.porcentaje_cumplimiento, :estado => sub.estado, :fecha => sub.updated_at.to_date, :usuario_id => uxp ? uxp.usuario_id : nil)
    end

    # Eliminamos la columnas sobrantes de subactividad 
    remove_column :subactividad, :porcentaje_cumplimiento
    remove_column :subactividad, :estado
  end

  def self.down
    add_column :subactividad, :porcentaje_cumplimiento, :decimal, :precision => 5, :scale => 4
    add_column :subactividad, :estado, :text
    # Restauramos los valores de las subactividades 
    Subactividad.all.each do |sub|
      vixs = ValorIntermedioXSubactividad.last(:order => ["fecha"], :conditions => {:subactividad_id => sub.id})
      if vixs
        sub.porcentaje_cumplimiento = vixs.porcentaje
        sub.estado = vixs.estado
        sub.save
      end
    end
    drop_table :valor_intermedio_x_subactividad
  end
end
